Index: extra/pylint.rc
===================================================================
--- extra/pylint.rc	(revision 5ef0633b151126a2a8e376666e05ccbcc0341316)
+++ extra/pylint.rc	(revision 823e6204f35d6c2bf32f27a3a3c137a369a973cf)
@@ -6,8 +6,9 @@
 # Python code to execute, usually for sys.path manipulation such as
 # pygtk.require().
-#init-hook=
+#init-hook='import os, sys; sys.path.extend([os.getcwd(),os.path.join(os.getcwd(),"extra")])'
+init-hook='import sys; sys.path.append('extra')
 
 # Profiled execution.
-profile=no
+#profile=no
 
 # Add files or directories to the blacklist. They should be base names, not
@@ -64,4 +65,5 @@
     star-args,
     unbalanced-tuple-unpacking,
+    locally-enabled,
     locally-disabled,
 
@@ -90,5 +92,5 @@
 # Add a comment according to your evaluation note. This is used by the global
 # evaluation report (RP0004).
-comment=no
+#comment=no
 
 # Template used to display messages. This is a python new-style format string
@@ -99,5 +101,5 @@
 
 # Required attributes for module, separated by a comma
-required-attributes=
+#required-attributes=
 
 # List of builtins function names that should not be used, separated by a comma
@@ -106,11 +108,11 @@
 # Good variable names which should always be accepted, separated by a comma
 good-names=_,
-    input,
-    i,j,k,n,x,y,z,
-    q,qx,qy,qz,
-    dt,dx,dy,dz,id,
-    Iq,dIq,Qx,Qy,Qz,
-    p,
+    input, id,
+    h, i, j, k, n, p, v, w, x, y, z,
+    q, qx, qy, qz, Q, Qx, Qy, Qz,
+    dt, dx, dy, dz, dq,
+    Iq, dIq, Iqxy, Iq_calc,
     ER, call_ER, VR, call_VR,
+    Rmax, SElength,
 
 # Bad variable names which should always be refused, separated by a comma
@@ -278,5 +280,6 @@
 # (useful for modules/projects where namespaces are manipulated during runtime
 # and thus existing member attributes cannot be deduced by static analysis
-ignored-modules=numpy,np
+ignored-modules=numpy,np,numpy.random,
+    bumps,sas,
 
 # List of classes names for which member attributes should not be checked
@@ -286,5 +289,5 @@
 # When zope mode is activated, add a predefined set of Zope acquired attributes
 # to generated-members.
-zope=no
+#zope=no
 
 # List of members which are set dynamically and missed by pylint inference
@@ -316,5 +319,5 @@
 # List of interface methods to ignore, separated by a comma. This is used for
 # instance to not check methods defines in Zope's Interface base class.
-ignore-iface-methods=isImplementedBy,deferred,extends,names,namesAndDescriptions,queryDescriptionFor,getBases,getDescriptionFor,getDoc,getName,getTaggedValue,getTaggedValueTags,isEqualOrExtendedBy,setTaggedValue,isImplementedByInstancesOf,adaptWith,is_implemented_by
+#ignore-iface-methods=isImplementedBy,deferred,extends,names,namesAndDescriptions,queryDescriptionFor,getBases,getDescriptionFor,getDoc,getName,getTaggedValue,getTaggedValueTags,isEqualOrExtendedBy,setTaggedValue,isImplementedByInstancesOf,adaptWith,is_implemented_by
 
 # List of method names used to declare (i.e. assign) instance attributes.
@@ -335,5 +338,5 @@
 
 # Maximum number of arguments for function / method
-max-args=5
+max-args=15
 
 # Argument names that match this expression will be ignored. Default to name
@@ -342,5 +345,5 @@
 
 # Maximum number of locals for function / method body
-max-locals=15
+max-locals=25
 
 # Maximum number of return / yield for function / method body
Index: extra/pylint_numpy.py
===================================================================
--- extra/pylint_numpy.py	(revision 63b32bbc85e7dea7a022cf604ac020dee56d7a88)
+++ extra/pylint_numpy.py	(revision 823e6204f35d6c2bf32f27a3a3c137a369a973cf)
@@ -8,5 +8,8 @@
     #print("processing",module.name)
     if module.name.startswith('numpy'):
-        if module.name == 'numpy':  import numpy
-        elif module.name == 'numpy.random': import numpy.random
+        if module.name == 'numpy':
+            import numpy
+        elif module.name == 'numpy.random':
+            import numpy.random
+            from numpy.random import seed, get_state, set_state
 
Index: extra/pylint_pyopencl.py
===================================================================
--- extra/pylint_pyopencl.py	(revision 3c56da87f0995bdde77f4183b68e77b81584dde0)
+++ extra/pylint_pyopencl.py	(revision 823e6204f35d6c2bf32f27a3a3c137a369a973cf)
@@ -9,2 +9,3 @@
     if module.name == 'pyopencl':
         import pyopencl
+        import pyopencl as cl
Index: extra/run-pylint.py
===================================================================
--- extra/run-pylint.py	(revision f01e53d5a96b16346f85048d4f125bc41f154611)
+++ extra/run-pylint.py	(revision 823e6204f35d6c2bf32f27a3a3c137a369a973cf)
@@ -6,11 +6,21 @@
 
 def main():
+    extra = abspath(dirname(__file__))
+    root = abspath(joinpath(extra, '..'))
+
     envpath = os.environ.get('PYTHONPATH',None)
     path = [envpath] if envpath else []
-    path.append(abspath(dirname(__file__))) # so we can find the plugins
+    path.append(extra)
+
+    #bumps = abspath(joinpath(root, "..", "bumps"))
+    #periodictable = abspath(joinpath(root, "..", "periodictable"))
+    #sasview = abspath(joinpath(root, "..", "sasview", "src"))
+    #path.extend((bumps, periodictable, sasview))
+
     os.environ['PYTHONPATH'] = ':'.join(path)
-    root = abspath(joinpath(dirname(__file__), '..'))
+
+    # Run the lint command
+    cmd = "pylint --rcfile extra/pylint.rc -f parseable sasmodels"
     os.chdir(root)
-    cmd = "pylint --rcfile extra/pylint.rc -f parseable sasmodels"
     status = os.system(cmd)
     sys.exit(status)
Index: sasmodels/__init__.py
===================================================================
--- sasmodels/__init__.py	(revision 989005365096670e54afec254875979f35bd395a)
+++ sasmodels/__init__.py	(revision 37a725200a1edb6dbd7a029a236c3ea2cfc7522c)
@@ -1,1 +1,17 @@
+"""
+sasmodels
+=========
+
+**sasmodels** is a package containing models for small angle neutron and xray
+scattering.  Models supported are the one dimensional circular average and
+two dimensional oriented patterns.  As well as the form factor calculations
+for the individual shapes **sasmodels** also provides automatic shape
+polydispersity, angular dispersion and resolution convolution.  SESANS
+patterns can be computed for any model.
+
+Models can be written in python or in C.  C models can run on the GPU if
+OpenCL drivers are available.  See :mod:`generate` for details on
+defining new models.
+"""
+
 __version__ = "0.9"
Index: sasmodels/bumps_model.py
===================================================================
--- sasmodels/bumps_model.py	(revision ec7e360eb9b8ec7bb8f5006ed71720a9fa7d593b)
+++ sasmodels/bumps_model.py	(revision 190fc2b167d3d89ca9c3b7d3128bdf8bde9f67d0)
@@ -6,6 +6,6 @@
 arguments to set the initial value for each parameter.
 
-:class:`Experiment` combines the *Model* function with a data file loaded by the
-sasview data loader.  *Experiment* takes a *cutoff* parameter controlling
+:class:`Experiment` combines the *Model* function with a data file loaded by
+the sasview data loader.  *Experiment* takes a *cutoff* parameter controlling
 how far the polydispersity integral extends.
 
@@ -19,19 +19,65 @@
 from .direct_model import DataMixin
 
+__all__ = [
+    "Model", "Experiment",
+    ]
+
 # CRUFT: old style bumps wrapper which doesn't separate data and model
+# pylint: disable=invalid-name
 def BumpsModel(data, model, cutoff=1e-5, **kw):
+    r"""
+    Bind a model to data, along with a polydispersity cutoff.
+
+    *data* is a :class:`data.Data1D`, :class:`data.Data2D` or
+    :class:`data.Sesans` object.  Use :func:`data.empty_data1D` or
+    :func:`data.empty_data2D` to define $q, \Delta q$ calculation
+    points for displaying the SANS curve when there is no measured data.
+
+    *model* is a runnable module as returned from :func:`core.load_model`.
+
+    *cutoff* is the polydispersity weight cutoff.
+
+    Any additional *key=value* pairs are model dependent parameters.
+
+    Returns an :class:`Experiment` object.
+
+    Note that the usual Bumps semantics is not fully supported, since
+    assigning *M.name = parameter* on the returned experiment object
+    does not set that parameter in the model.  Range setting will still
+    work as expected though.
+
+    .. deprecated:: 0.1
+        Use :class:`Experiment` instead.
+    """
     warnings.warn("Use of BumpsModel is deprecated.  Use bumps_model.Experiment instead.")
+
+    # Create the model and experiment
     model = Model(model, **kw)
     experiment = Experiment(data=data, model=model, cutoff=cutoff)
-    for k in model._parameter_names:
-        setattr(experiment, k, getattr(model, k))
+
+    # Copy the model parameters up to the experiment object.
+    for k, v in model.parameters().items():
+        setattr(experiment, k, v)
     return experiment
 
+
 def create_parameters(model_info, **kwargs):
+    """
+    Generate Bumps parameters from the model info.
+
+    *model_info* is returned from :func:`generate.model_info` on the
+    model definition module.
+
+    Any additional *key=value* pairs are initial values for the parameters
+    to the models.  Uninitialized parameters will use the model default
+    value.
+
+    Returns a dictionary of *{name: Parameter}* containing the bumps
+    parameters for each model parameter, and a dictionary of
+    *{name: str}* containing the polydispersity distribution types.
+    """
     # lazy import; this allows the doc builder and nosetests to run even
     # when bumps is not on the path.
     from bumps.names import Parameter
-
-    partype = model_info['partype']
 
     pars = {}
@@ -40,10 +86,10 @@
         value = kwargs.pop(name, default)
         pars[name] = Parameter.default(value, name=name, limits=limits)
-    for name in partype['pd-2d']:
+    for name in model_info['partype']['pd-2d']:
         for xpart, xdefault, xlimits in [
-            ('_pd', 0., limits),
-            ('_pd_n', 35., (0, 1000)),
-            ('_pd_nsigma', 3., (0, 10)),
-        ]:
+                ('_pd', 0., limits),
+                ('_pd_n', 35., (0, 1000)),
+                ('_pd_nsigma', 3., (0, 10)),
+            ]:
             xname = name + xpart
             xvalue = kwargs.pop(xname, xdefault)
@@ -51,5 +97,5 @@
 
     pd_types = {}
-    for name in partype['pd-2d']:
+    for name in model_info['partype']['pd-2d']:
         xname = name + '_pd_type'
         xvalue = kwargs.pop(xname, 'gaussian')
@@ -63,10 +109,19 @@
 
 class Model(object):
+    """
+    Bumps wrapper for a SAS model.
+
+    *model* is a runnable module as returned from :func:`core.load_model`.
+
+    *cutoff* is the polydispersity weight cutoff.
+
+    Any additional *key=value* pairs are model dependent parameters.
+    """
     def __init__(self, model, **kwargs):
         self._sasmodel = model
         pars, pd_types = create_parameters(model.info, **kwargs)
-        for k,v in pars.items():
+        for k, v in pars.items():
             setattr(self, k, v)
-        for k,v in pd_types.items():
+        for k, v in pd_types.items():
             setattr(self, k, v)
         self._parameter_names = list(pars.keys())
@@ -75,9 +130,14 @@
     def parameters(self):
         """
-        Return a dictionary of parameters
+        Return a dictionary of parameters objects for the parameters,
+        excluding polydispersity distribution type.
         """
         return dict((k, getattr(self, k)) for k in self._parameter_names)
 
     def state(self):
+        """
+        Return a dictionary of current values for all the parameters,
+        including polydispersity distribution type.
+        """
         pars = dict((k, getattr(self, k).value) for k in self._parameter_names)
         pars.update((k, getattr(self, k)) for k in self._pd_type_names)
@@ -85,18 +145,18 @@
 
 class Experiment(DataMixin):
-    """
-    Return a bumps wrapper for a SAS model.
-
-    *data* is the data to be fitted.
-
-    *model* is the SAS model from :func:`core.load_model`.
+    r"""
+    Bumps wrapper for a SAS experiment.
+
+    *data* is a :class:`data.Data1D`, :class:`data.Data2D` or
+    :class:`data.Sesans` object.  Use :func:`data.empty_data1D` or
+    :func:`data.empty_data2D` to define $q, \Delta q$ calculation
+    points for displaying the SANS curve when there is no measured data.
+
+    *model* is a :class:`Model` object.
 
     *cutoff* is the integration cutoff, which avoids computing the
     the SAS model where the polydispersity weight is low.
 
-    Model parameters can be initialized with additional keyword
-    arguments, or by assigning to model.parameter_name.value.
-
-    The resulting bumps model can be used directly in a FitProblem call.
+    The resulting model can be used directly in a Bumps FitProblem call.
     """
     def __init__(self, data, model, cutoff=1e-5):
@@ -109,9 +169,13 @@
 
     def update(self):
+        """
+        Call when model parameters have changed and theory needs to be
+        recalculated.
+        """
         self._cache = {}
 
     def numpoints(self):
         """
-            Return the number of points
+        Return the number of data points
         """
         return len(self.Iq)
@@ -124,4 +188,10 @@
 
     def theory(self):
+        """
+        Return the theory corresponding to the model parameters.
+
+        This method uses lazy evaluation, and requires model.update() to be
+        called when the parameters have changed.
+        """
         if 'theory' not in self._cache:
             pars = self.model.state()
@@ -130,8 +200,16 @@
 
     def residuals(self):
+        """
+        Return theory minus data normalized by uncertainty.
+        """
         #if np.any(self.err ==0): print("zeros in err")
         return (self.theory() - self.Iq) / self.dIq
 
     def nllf(self):
+        """
+        Return the negative log likelihood of seeing data given the model
+        parameters, up to a normalizing constant which depends on the data
+        uncertainty.
+        """
         delta = self.residuals()
         #if np.any(np.isnan(R)): print("NaN in residuals")
@@ -149,8 +227,16 @@
 
     def simulate_data(self, noise=None):
+        """
+        Generate simulated data.
+        """
         Iq = self.theory()
         self._set_data(Iq, noise)
 
     def save(self, basename):
+        """
+        Save the model parameters and data into a file.
+
+        Not Implemented.
+        """
         pass
 
Index: sasmodels/compare.py
===================================================================
--- sasmodels/compare.py	(revision 608e31e3a7d22b75d2b3b9ec919739d9345a9afb)
+++ sasmodels/compare.py	(revision d5e650da432c58f8cd7c4d86e8ecb26828e17a21)
@@ -28,4 +28,20 @@
 
 from __future__ import print_function
+
+import sys
+import math
+from os.path import basename, dirname, join as joinpath
+import glob
+import datetime
+import traceback
+
+import numpy as np
+
+from . import core
+from . import kerneldll
+from . import generate
+from .data import plot_theory, empty_data1D, empty_data2D
+from .direct_model import DirectModel
+from .convert import revert_model, constrain_new_to_old
 
 USAGE = """
@@ -72,34 +88,16 @@
 # doc string so that we can display it at run time if there is an error.
 # lin
-__doc__ = __doc__ + """
+__doc__ = (__doc__  # pylint: disable=redefined-builtin
+           + """
 Program description
 -------------------
 
-""" + USAGE
-
-
-
-import sys
-import math
-from os.path import basename, dirname, join as joinpath
-import glob
-import datetime
-import traceback
-
-import numpy as np
-
+"""
+           + USAGE)
+
+kerneldll.ALLOW_SINGLE_PRECISION_DLLS = True
+
+# List of available models
 ROOT = dirname(__file__)
-sys.path.insert(0, ROOT)  # Make sure sasmodels is first on the path
-
-
-from . import core
-from . import kerneldll
-from . import generate
-from .data import plot_theory, empty_data1D, empty_data2D
-from .direct_model import DirectModel
-from .convert import revert_model, constrain_new_to_old
-kerneldll.ALLOW_SINGLE_PRECISION_DLLS = True
-
-# List of available models
 MODELS = [basename(f)[:-3]
           for f in sorted(glob.glob(joinpath(ROOT, "models", "[a-zA-Z]*.py")))]
@@ -115,4 +113,72 @@
         return dt.total_seconds()
 
+
+class push_seed(object):
+    """
+    Set the seed value for the random number generator.
+
+    When used in a with statement, the random number generator state is
+    restored after the with statement is complete.
+
+    :Parameters:
+
+    *seed* : int or array_like, optional
+        Seed for RandomState
+
+    :Example:
+
+    Seed can be used directly to set the seed::
+
+        >>> from numpy.random import randint
+        >>> push_seed(24)
+        <...push_seed object at...>
+        >>> print(randint(0,1000000,3))
+        [242082    899 211136]
+
+    Seed can also be used in a with statement, which sets the random
+    number generator state for the enclosed computations and restores
+    it to the previous state on completion::
+
+        >>> with push_seed(24):
+        ...    print(randint(0,1000000,3))
+        [242082    899 211136]
+
+    Using nested contexts, we can demonstrate that state is indeed
+    restored after the block completes::
+
+        >>> with push_seed(24):
+        ...    print(randint(0,1000000))
+        ...    with push_seed(24):
+        ...        print(randint(0,1000000,3))
+        ...    print(randint(0,1000000))
+        242082
+        [242082    899 211136]
+        899
+
+    The restore step is protected against exceptions in the block::
+
+        >>> with push_seed(24):
+        ...    print(randint(0,1000000))
+        ...    try:
+        ...        with push_seed(24):
+        ...            print(randint(0,1000000,3))
+        ...            raise Exception()
+        ...    except:
+        ...        print("Exception raised")
+        ...    print(randint(0,1000000))
+        242082
+        [242082    899 211136]
+        Exception raised
+        899
+    """
+    def __init__(self, seed=None):
+        self._state = np.random.get_state()
+        np.random.seed(seed)
+
+    def __enter__(self):
+        return None
+
+    def __exit__(self, *args):
+        np.random.set_state(self._state)
 
 def tic():
@@ -177,4 +243,5 @@
         return [0, (2*v if v > 0 else 1)]
 
+
 def _randomize_one(p, v):
     """
@@ -186,4 +253,5 @@
         return np.random.uniform(*parameter_range(p, v))
 
+
 def randomize_pars(pars, seed=None):
     """
@@ -195,8 +263,8 @@
     :func:`constrain_pars` needs to be called afterward..
     """
-    np.random.seed(seed)
-    # Note: the sort guarantees order `of calls to random number generator
-    pars = dict((p, _randomize_one(p, v))
-                for p, v in sorted(pars.items()))
+    with push_seed(seed):
+        # Note: the sort guarantees order `of calls to random number generator
+        pars = dict((p, _randomize_one(p, v))
+                    for p, v in sorted(pars.items()))
     return pars
 
@@ -281,5 +349,6 @@
             theory = lambda: smearer.get_value()
         else:
-            theory = lambda: model.evalDistribution([data.qx_data[index], data.qy_data[index]])
+            theory = lambda: model.evalDistribution([data.qx_data[index],
+                                                     data.qy_data[index]])
     elif smearer is not None:
         theory = lambda: smearer(model.evalDistribution(data.x))
@@ -416,5 +485,6 @@
         try:
             base_value, base_time = time_calculation(base, pars, Nbase)
-            print("%s t=%.1f ms, intensity=%.0f"%(base.engine, base_time, sum(base_value)))
+            print("%s t=%.1f ms, intensity=%.0f"
+                  % (base.engine, base_time, sum(base_value)))
         except ImportError:
             traceback.print_exc()
@@ -426,5 +496,6 @@
         try:
             comp_value, comp_time = time_calculation(comp, pars, Ncomp)
-            print("%s t=%.1f ms, intensity=%.0f"%(comp.engine, comp_time, sum(comp_value)))
+            print("%s t=%.1f ms, intensity=%.0f"
+                  % (comp.engine, comp_time, sum(comp_value)))
         except ImportError:
             traceback.print_exc()
@@ -433,12 +504,11 @@
     # Compare, but only if computing both forms
     if Nbase > 0 and Ncomp > 0:
-        #print("speedup %.2g"%(comp_time/base_time))
-        #print("max |base/comp|", max(abs(base_value/comp_value)), "%.15g"%max(abs(base_value)), "%.15g"%max(abs(comp_value)))
-        #comp *= max(base_value/comp_value)
         resid = (base_value - comp_value)
         relerr = resid/comp_value
-        _print_stats("|%s-%s|"%(base.engine, comp.engine) + (" "*(3+len(comp.engine))),
+        _print_stats("|%s-%s|"
+                     % (base.engine, comp.engine) + (" "*(3+len(comp.engine))),
                      resid)
-        _print_stats("|(%s-%s)/%s|"%(base.engine, comp.engine, comp.engine),
+        _print_stats("|(%s-%s)/%s|"
+                     % (base.engine, comp.engine, comp.engine),
                      relerr)
 
@@ -459,20 +529,22 @@
     if Nbase > 0:
         if Ncomp > 0: plt.subplot(131)
-        plot_theory(data, base_value, view=view, plot_data=False, limits=limits)
+        plot_theory(data, base_value, view=view, use_data=False, limits=limits)
         plt.title("%s t=%.1f ms"%(base.engine, base_time))
         #cbar_title = "log I"
     if Ncomp > 0:
         if Nbase > 0: plt.subplot(132)
-        plot_theory(data, comp_value, view=view, plot_data=False, limits=limits)
+        plot_theory(data, comp_value, view=view, use_data=False, limits=limits)
         plt.title("%s t=%.1f ms"%(comp.engine, comp_time))
         #cbar_title = "log I"
     if Ncomp > 0 and Nbase > 0:
         plt.subplot(133)
-        if '-abs' in opts:
+        if not opts['rel_err']:
             err, errstr, errview = resid, "abs err", "linear"
         else:
             err, errstr, errview = abs(relerr), "rel err", "log"
         #err,errstr = base/comp,"ratio"
-        plot_theory(data, None, resid=err, view=errview, plot_data=False)
+        plot_theory(data, None, resid=err, view=errview, use_data=False)
+        if view == 'linear':
+            plt.xscale('linear')
         plt.title("max %s = %.3g"%(errstr, max(abs(err))))
         #cbar_title = errstr if errview=="linear" else "log "+errstr
@@ -534,5 +606,7 @@
 def columnize(L, indent="", width=79):
     """
-    Format a list of strings into columns for printing.
+    Format a list of strings into columns.
+
+    Returns a string with carriage returns ready for printing.
     """
     column_width = max(len(w) for w in L) + 1
@@ -591,5 +665,5 @@
     invalid = [o[1:] for o in flags
                if o[1:] not in NAME_OPTIONS
-                   and not any(o.startswith('-%s='%t) for t in VALUE_OPTIONS)]
+               and not any(o.startswith('-%s='%t) for t in VALUE_OPTIONS)]
     if invalid:
         print("Invalid options: %s"%(", ".join(invalid)))
@@ -597,4 +671,5 @@
 
 
+    # pylint: disable=bad-whitespace
     # Interpret the flags
     opts = {
@@ -651,4 +726,5 @@
         elif arg == '-sasview': engines.append(arg[1:])
         elif arg == '-edit':    opts['explore'] = True
+    # pylint: enable=bad-whitespace
 
     if len(engines) == 0:
@@ -675,9 +751,9 @@
     presets = {}
     for arg in values:
-        k,v = arg.split('=',1)
+        k, v = arg.split('=', 1)
         if k not in pars:
             # extract base name without polydispersity info
             s = set(p.split('_pd')[0] for p in pars)
-            print("%r invalid; parameters are: %s"%(k,", ".join(sorted(s))))
+            print("%r invalid; parameters are: %s"%(k, ", ".join(sorted(s))))
             sys.exit(1)
         presets[k] = float(v) if not k.endswith('type') else v
@@ -697,5 +773,5 @@
 
     # Create the computational engines
-    data, _index = make_data(opts)
+    data, _ = make_data(opts)
     if n1:
         base = make_engine(model_definition, data, engines[0], opts['cutoff'])
@@ -707,4 +783,5 @@
         comp = None
 
+    # pylint: disable=bad-whitespace
     # Remember it all
     opts.update({
@@ -718,15 +795,12 @@
         'engines'   : [base, comp],
     })
+    # pylint: enable=bad-whitespace
 
     return opts
 
-def main():
-    opts = parse_opts()
-    if opts['explore']:
-        explore(opts)
-    else:
-        compare(opts)
-
 def explore(opts):
+    """
+    Explore the model using the Bumps GUI.
+    """
     import wx
     from bumps.names import FitProblem
@@ -734,17 +808,20 @@
 
     problem = FitProblem(Explore(opts))
-    isMac = "cocoa" in wx.version()
+    is_mac = "cocoa" in wx.version()
     app = wx.App()
     frame = AppFrame(parent=None, title="explore")
-    if not isMac: frame.Show()
+    if not is_mac: frame.Show()
     frame.panel.set_model(model=problem)
     frame.panel.Layout()
     frame.panel.aui.Split(0, wx.TOP)
-    if isMac: frame.Show()
+    if is_mac: frame.Show()
     app.MainLoop()
 
 class Explore(object):
     """
-    Return a bumps wrapper for a SAS model comparison.
+    Bumps wrapper for a SAS model comparison.
+
+    The resulting object can be used as a Bumps fit problem so that
+    parameters can be adjusted in the GUI, with plots updated on the fly.
     """
     def __init__(self, opts):
@@ -787,4 +864,5 @@
         Return cost.
         """
+        # pylint: disable=no-self-use
         return 0.  # No nllf
 
@@ -804,4 +882,14 @@
 
 
+def main():
+    """
+    Main program.
+    """
+    opts = parse_opts()
+    if opts['explore']:
+        explore(opts)
+    else:
+        compare(opts)
+
 if __name__ == "__main__":
     main()
Index: sasmodels/compare_many.py
===================================================================
--- sasmodels/compare_many.py	(revision 6458608d36e65099c9e90af3b188b8a10cadb474)
+++ sasmodels/compare_many.py	(revision 4f2478e77cdc4e495cf403a9aeb9c6544bcdf468)
@@ -1,3 +1,15 @@
 #!/usr/bin/env python
+"""
+Program to compare results from many random parameter sets for a given model.
+
+The result is a comma separated value (CSV) table that can be redirected
+from standard output into a file and loaded into a spreadsheet.
+
+The models are compared for each parameter set and if the difference is
+greater than expected for that precision, the parameter set is labeled
+as bad and written to the output, along with the random seed used to
+generate that parameter value.  This seed can be used with :mod:`compare`
+to reload and display the details of the model.
+"""
 from __future__ import print_function
 
@@ -14,16 +26,38 @@
 
 def calc_stats(target, value, index):
+    """
+    Calculate statistics between the target value and the computed value.
+
+    *target* and *value* are the vectors being compared, with the
+    difference normalized by *target* to get relative error.  Only
+    the elements listed in *index* are used, though index may be
+    and empty slice defined by *slice(None, None)*.
+
+    Returns:
+
+        *maxrel* the maximum relative difference
+
+        *rel95* the relative difference with the 5% biggest differences ignored
+
+        *maxabs* the maximum absolute difference for the 5% biggest differences
+
+        *maxval* the maximum value for the 5% biggest differences
+    """
     resid = abs(value-target)[index]
     relerr = resid/target[index]
-    srel = np.argsort(relerr)
+    sorted_rel_index = np.argsort(relerr)
     #p90 = int(len(relerr)*0.90)
     p95 = int(len(relerr)*0.95)
     maxrel = np.max(relerr)
-    rel95 = relerr[srel[p95]]
-    maxabs = np.max(resid[srel[p95:]])
-    maxval = np.max(value[srel[p95:]])
-    return maxrel,rel95,maxabs,maxval
+    rel95 = relerr[sorted_rel_index[p95]]
+    maxabs = np.max(resid[sorted_rel_index[p95:]])
+    maxval = np.max(value[sorted_rel_index[p95:]])
+    return maxrel, rel95, maxabs, maxval
 
 def print_column_headers(pars, parts):
+    """
+    Generate column headers for the differences and for the parameters,
+    and print them to standard output.
+    """
     stats = list('Max rel err|95% rel err|Max abs err above 90% rel|Max value above 90% rel'.split('|'))
     groups = ['']
@@ -36,4 +70,5 @@
     print(','.join('"%s"'%c for c in columns))
 
+# Target 'good' value for various precision levels.
 PRECISION = {
     'fast': 1e-3,
@@ -48,13 +83,30 @@
 def compare_instance(name, data, index, N=1, mono=True, cutoff=1e-5,
                      base='sasview', comp='double'):
-    is2D = hasattr(data, 'qx_data')
+    r"""
+    Compare the model under different calculation engines.
+
+    *name* is the name of the model.
+
+    *data* is the data object giving $q, \Delta q$ calculation points.
+
+    *index* is the active set of points.
+
+    *N* is the number of comparisons to make.
+
+    *cutoff* is the polydispersity weight cutoff to make the calculation
+    a little bit faster.
+
+    *base* and *comp* are the names of the calculation engines to compare.
+    """
+
+    is_2d = hasattr(data, 'qx_data')
     model_definition = core.load_model_definition(name)
     pars = get_demo_pars(model_definition)
     header = ('\n"Model","%s","Count","%d","Dimension","%s"'
-              % (name, N, "2D" if is2D else "1D"))
+              % (name, N, "2D" if is_2d else "1D"))
     if not mono: header += ',"Cutoff",%g'%(cutoff,)
     print(header)
 
-    if is2D:
+    if is_2d:
         info = generate.make_info(model_definition)
         partype = info['partype']
@@ -69,4 +121,8 @@
     # declarations are not available in python 2.7.
     def try_model(fn, pars):
+        """
+        Return the model evaluated at *pars*.  If there is an exception,
+        print it and return NaN of the right shape.
+        """
         try:
             result = fn(**pars)
@@ -82,4 +138,8 @@
         return result
     def check_model(pars):
+        """
+        Run the two calculators against *pars*, returning statistics
+        on the differences.  See :func:`calc_stats` for the list of stats.
+        """
         base_value = try_model(calc_base, pars)
         comp_value = try_model(calc_comp, pars)
@@ -108,5 +168,5 @@
         good = [True]
         columns = check_model(pars_i)
-        columns += [v for _,v in sorted(pars_i.items())]
+        columns += [v for _, v in sorted(pars_i.items())]
         if first:
             labels = [" vs. ".join((calc_base.engine, calc_comp.engine))]
@@ -121,12 +181,21 @@
 
 def print_usage():
+    """
+    Print the command usage string.
+    """
     print("usage: compare_many.py MODEL COUNT (1dNQ|2dNQ) (CUTOFF|mono) (single|double|quad)")
 
 
 def print_models():
+    """
+    Print the list of available models in columns.
+    """
     print(columnize(MODELS, indent="  "))
 
 
 def print_help():
+    """
+    Print usage string, the option description and the list of available models.
+    """
     print_usage()
     print("""\
@@ -158,5 +227,8 @@
 
 def main():
-    if len(sys.argv) not in (6,7):
+    """
+    Main program.
+    """
+    if len(sys.argv) not in (6, 7):
         print_help()
         sys.exit(1)
@@ -182,5 +254,5 @@
 
     data, index = make_data({'qmax':1.0, 'is2d':is2D, 'nq':Nq, 'res':0.,
-                              'accuracy': 'Low', 'view':'log'})
+                             'accuracy': 'Low', 'view':'log'})
     model_list = [model] if model != "all" else MODELS
     for model in model_list:
@@ -189,3 +261,5 @@
 
 if __name__ == "__main__":
+    #from .compare import push_seed
+    #with push_seed(1): main()
     main()
